<!-- 编辑弹窗 -->
<template>
  <ele-modal
    :width="1000"
    :visible="visible"
    :maskClosable="false"
    :maxable="true"
    :title="isUpdate ? '编辑页面' : '添加页面'"
    :body-style="{ paddingBottom: '28px' }"
    @update:visible="updateVisible"
    @ok="save"
  >
    <a-form
      ref="formRef"
      :model="form"
      :rules="rules"
      :label-col="styleResponsive ? { md: 2, sm: 5, xs: 24 } : { flex: '90px' }"
      :wrapper-col="
        styleResponsive ? { md: 21, sm: 19, xs: 24 } : { flex: '1' }
      "
    >
      <a-form-item label="页面名称" name="name">
        <a-input
          allow-clear
          :maxlength="100"
          placeholder="关于我们"
          v-model:value="form.name"
        />
      </a-form-item>
      <a-form-item label="路由地址" name="path" :extra="form.path ? `${form.path}` : ''">
        <a-input
          allow-clear
          :maxlength="100"
          placeholder="/about"
          v-model:value="form.path"
        />
      </a-form-item>
      <a-form-item label="组件路径" name="component" :extra="form.component ? `@/views${form.component}` : ''">
        <a-input
          allow-clear
          :maxlength="100"
          placeholder="请输入组件路径"
          v-model:value="form.component"
        />
      </a-form-item>
      <a-form-item label="Banner" name="photo">
        <SelectFile
          :placeholder="`请选择图片`"
          :limit="1"
          :data="images"
          @done="chooseFile"
          @del="onDeleteItem"
        />
<!--        <ele-image-upload-->
<!--          v-model:value="images"-->
<!--          :limit="1"-->
<!--          :drag="true"-->
<!--          :upload-handler="uploadHandler"-->
<!--          @upload="onUpload"-->
<!--        />-->
      </a-form-item>
      <a-form-item label="页面内容" name="content">
        <!-- 编辑器 -->
        <div class="content">
          <tinymce-editor
            v-model:value="content"
            :disabled="disabled"
            :init="config"
            placeholder="图片直接粘贴自动上传"
            @paste="onPaste"
          />
        </div>
      </a-form-item>
      <a-form-item label="排序号" name="sortNumber">
        <a-input-number
          :min="0"
          :max="9999"
          class="ele-fluid"
          placeholder="请输入排序号"
          v-model:value="form.sortNumber"
        />
      </a-form-item>
      <a-form-item label="状态" name="status">
        <a-radio-group v-model:value="form.status">
          <a-radio :value="0">开启</a-radio>
          <a-radio :value="1">关闭</a-radio>
        </a-radio-group>
      </a-form-item>
    </a-form>
  </ele-modal>
</template>

<script lang="ts" setup>
  import { ref, reactive, watch } from 'vue';
  import { Form, message } from 'ant-design-vue';
  import {assignObject, uuid} from 'ele-admin-pro';
  import { addDesign, updateDesign } from '@/api/cms/design';
  import { Design } from '@/api/cms/design/model';
  import { useThemeStore } from '@/store/modules/theme';
  import { storeToRefs } from 'pinia';
  import { FormInstance, RuleObject } from 'ant-design-vue/es/form';
  import { ItemType } from 'ele-admin-pro/es/ele-image-upload/types';
  import {uploadFile, uploadOss} from '@/api/system/file';
  import TinymceEditor from "@/components/TinymceEditor/index.vue";
  import useFormData from "@/utils/use-form-data";
  import type {Article} from "@/api/cms/article/model";
  import {ArticleCategory} from "@/api/cms/category/model";
  import {removeSiteInfoCache} from "@/api/cms/website";
  import success from "@/views/result/success/index.vue";
  import {FileRecord} from "@/api/system/file/model";

  // 是否是修改
  const isUpdate = ref(false);
  const useForm = Form.useForm;
  // 是否开启响应式布局
  const themeStore = useThemeStore();
  const { styleResponsive } = storeToRefs(themeStore);
  const disabled = ref(false);
  // 编辑器内容，双向绑定
  const content = ref<any>('');

  const props = defineProps<{
    // 弹窗是否打开
    visible: boolean;
    // 修改回显的数据
    data?: Design | null;
  }>();

  const emit = defineEmits<{
    (e: 'done'): void;
    (e: 'update:visible', visible: boolean): void;
  }>();

  // 提交状态
  const loading = ref(false);
  // 已上传数据
  const images = ref<ItemType[]>([]);
  // 表格选中数据
  const formRef = ref<FormInstance | null>(null);

  // 表单数据
  const { form, resetFields, assignFields } = useFormData<Design>({
    pageId: undefined,
    name: '',
    images: '',
    path: '',
    component: '/about/index',
    content: '',
    type: '',
    status: 0,
    comments: '',
    sortNumber: 100
  });

  const editorRef = ref<InstanceType<typeof TinymceEditor> | null>(null);
  const config = ref({
    height: 500,
    images_upload_handler: (blobInfo, success, error) => {
      const file = blobInfo.blob();
      const formData = new FormData();
      formData.append('file', file, file.name);
      uploadOss(file).then(res => {
        success(res.url)
      }).catch((msg) => {
        error(msg);
      })
      return false;
    },
    // 自定义文件上传(这里使用把选择的文件转成 blob 演示)
    file_picker_callback: (callback: any, _value: any, meta: any) => {
      const input = document.createElement('input');
      input.setAttribute('type', 'file');
      // 设定文件可选类型
      if (meta.filetype === 'image') {
        input.setAttribute('accept', 'image/*');
      } else if (meta.filetype === 'media') {
        input.setAttribute('accept', 'video/*,.pdf');
      }
      input.onchange = () => {
        const file = input.files?.[0];
        if (!file) {
          return;
        }
        if (meta.filetype === 'media') {
          if (file.size / 1024 / 1024 > 200) {
            editorRef.value?.alert({ content: '大小不能超过 200MB' });
            return;
          }
          if (!file.type.startsWith('video/')) {
            editorRef.value?.alert({ content: '只能选择视频文件' });
            return;
          }
          uploadOss(file).then(res => {
            callback(res.downloadUrl);
          })
        }
      };
      input.click();
    }
  });

  /* 粘贴图片上传服务器并插入编辑器 */
  const onPaste = (e) => {
    const items = (e.clipboardData || e.originalEvent.clipboardData).items;
    let hasFile = false;
    for (let i = 0; i < items.length; i++) {
      if (items[i].type.indexOf('image') !== -1) {
        let file = items[i].getAsFile();
        const item: ItemType = {
          file,
          uid: (file as any).lastModified,
          name: file.name
        };
        uploadFile(<File>item.file)
          .then((result) => {
            const addPath = `<p><img class="content-img" src="${result.url}"></p>`;
            content.value = content.value + addPath
          })
          .catch((e) => {
            message.error(e.message);
          });
        hasFile = true;
      }
    }
    if (hasFile) {
      e.preventDefault();
    }
  }

  /* 更新visible */
  const updateVisible = (value: boolean) => {
    emit('update:visible', value);
  };

  // 表单验证规则
  const rules = reactive({
    name: [
      {
        required: true,
        type: 'string',
        message: '请填写页面名称',
        trigger: 'blur'
      }
    ],
    path: [
      {
        required: true,
        type: 'string',
        message: '请填写路由地址',
        trigger: 'blur'
      }
    ],
    component: [
      {
        required: true,
        type: 'string',
        message: '请填写组件路径',
        trigger: 'blur'
      }
    ]
  });

  /* 上传事件 */
  const uploadHandler = (file: File) => {
    const item: ItemType = {
      file,
      uid: (file as any).uid,
      name: file.name
    };
    if (file.type.startsWith('video')) {
      if (file.size / 1024 / 1024 > 200) {
        message.error('大小不能超过 200MB');
        return;
      }
    }
    if (file.type.startsWith('image')) {
      if (file.size / 1024 / 1024 > 5) {
        message.error('大小不能超过 5MB');
        return;
      }
    }

    onUpload(item);
  };

  // 上传文件
  const onUpload = (item: any) => {
    const { file } = item;
    uploadFile(file)
      .then((data) => {
        form.photo = data.path;
        images.value.push({
          uid: data.id,
          url:
            file.type == 'video/mp4'
              ? 'https://oss.wsdns.cn/20240301/6e4e32cb808245d4be336b9486961145.png'
              : data.path,
          status: 'done'
        });
      })
      .catch((e) => {
        message.error(e.message);
      });
  };

  const chooseFile = (data: FileRecord) => {
    images.value.push({
      uid: data.id,
      url: data.downloadUrl,
      status: 'done'
    });
    form.photo = data.downloadUrl;
  }

  const onDeleteItem = (index: number) => {
    images.value.splice(index,1)
    form.photo = '';
  }


  /* 保存编辑 */
  const save = () => {
    if (!formRef.value) {
      return;
    }
    formRef.value
      .validate()
      .then(() => {
        loading.value = true;
        const formData = {
          ...form,
          content: content.value
        };
        const saveOrUpdate = isUpdate.value ? updateDesign : addDesign;
        saveOrUpdate(formData)
          .then((msg) => {
            loading.value = false;
            message.success(msg);
            updateVisible(false);
            // 清除缓存
            removeSiteInfoCache('SiteInfo:' + localStorage.getItem('TenantId'));
            emit('done');
          })
          .catch((e) => {
            loading.value = false;
            message.error(e.message);
          });
      })
      .catch(() => {});
  };

  watch(
    () => props.visible,
    (visible) => {
      if (visible) {
        content.value = ''
        images.value = []
        if (props.data) {
          assignFields(props.data);
          if(props.data.content){
            content.value = props.data.content
          }
          if(props.data.photo){
            images.value.push({
              uid: uuid(),
              url: props.data.photo,
              status: 'done'
            })
          }
          isUpdate.value = true;
        } else {
          isUpdate.value = false;
          content.value = '';
        }
      } else {
        resetFields();
        formRef.value?.clearValidate();
      }
    },
    { immediate: true }
  );
</script>
<style lang="less">
.sdf{
  display: none;
}
</style>
